/*==============================================================================
 Fraclet annotation - Copyright (C) 2002-2006 INRIA Futurs / LIFL
 Fractal Component Model (contact: fractal@objectweb.org)

 This library is free software; you can redistribute it and/or modify it under 
 the terms of the GNU Lesser General Public License as published by the Free 
 Software Foundation; either version 2.1 of the License, or any later version.

 This library is distributed in the hope that it will be useful, but WITHOUT ANY 
 WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License along 
 with this library; if not, write to the Free Software Foundation, Inc., 
 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

 Initial developer(s): Nicolas Pessemier (nicolas.pessemier@lifl.fr)
 ==============================================================================*/
package org.objectweb.fractal.fraclet.annotation.ant;

import org.apache.tools.ant.BuildException;
import org.objectweb.fractal.fraclet.annotation.processor.AttributeProcessor;
import org.objectweb.fractal.fraclet.annotation.processor.ComponentProcessor;
import org.objectweb.fractal.fraclet.annotation.processor.InterfaceProcessor;
import org.objectweb.fractal.fraclet.annotation.processor.MonologHandlerProcessor;
import org.objectweb.fractal.fraclet.annotation.processor.MonologProcessor;
import org.objectweb.fractal.fraclet.annotation.processor.ServiceProcessor;

import spoon.SpoonTask;
import spoon.aval.processing.AValProcessor;

/**
 * Defines the ANT Fraclet-annotation task (processors are
 * {@link spoon.aval.processing.AValProcessor},
 * {@link org.objectweb.fractal.fraclet.annotation.processor.ComponentProcessor},
 * {@link org.objectweb.fractal.fraclet.annotation.processor.AttributeProcessor},
 * {@link org.objectweb.fractal.fraclet.annotation.processor.InterfaceProcessor},
 * {@link org.objectweb.fractal.fraclet.annotation.processor.MonologProcessor},
 * {@link org.objectweb.fractal.fraclet.annotation.processor.ServiceProcessor},
 * and
 * {@link org.objectweb.fractal.fraclet.annotation.processor.LifeCycleProcessor})
 */
public class FracletAnnotation extends SpoonTask {

	/**
	 * Default constructor.
	 */
	public FracletAnnotation() {
	}

	@Override
	public void execute() throws BuildException {
		addProcessor(new ProcessorType(AValProcessor.class.getCanonicalName()));

		addProcessor(new ProcessorType(ComponentProcessor.class
				.getCanonicalName()));
		addProcessor(new ProcessorType(AttributeProcessor.class
				.getCanonicalName()));

		addProcessor(new ProcessorType(InterfaceProcessor.class
				.getCanonicalName()));
		addProcessor(new ProcessorType(MonologHandlerProcessor.class
				.getCanonicalName()));
		addProcessor(new ProcessorType(MonologProcessor.class
				.getCanonicalName()));
		addProcessor(new ProcessorType(ServiceProcessor.class
				.getCanonicalName()));
//		addProcessor(new ProcessorType(LifeCycleProcessor.class
//				.getCanonicalName()));

		super.execute();

	}

}
